//+------------------------------------------------------------------+
//|                                              HAMa Step Histo.mq4 |
//|                                    Heiken Ashi Step Ma Histogram |
//+------------------------------------------------------------------+
//|                                                      mod by Raff |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_width1 2
#property indicator_width2 2
#property indicator_minimum 0

//---- parameters
extern int StepMode  = 1;
extern int MaMetod  = 1;
extern int MaPeriod = 20;
extern int Step = 0;
extern bool alertsOn        = false;
extern bool alertsOnCurrent = true;
extern bool alertsMessage   = true;
extern bool alertsSound     = false;
extern bool alertsEmail     = false;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double trend[];
//----
int ExtCountedBars=0;
//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
  {
//---- Indicators
   IndicatorBuffers(5);
   SetIndexBuffer(0,ExtMapBuffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,ExtMapBuffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexBuffer(4,trend);
   IndicatorShortName("HAMa Step Histo"+" | "+StepMode+", "+MaMetod+", "+MaPeriod+", "+Step+" | "); 
   return(0);
}
//------------------------------------------------------------------
//
//------------------------------------------------------------------
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for (int pos=limit; pos>=0; pos--)
   {
      double maOpen  = iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_OPEN ,pos);
      double maClose = iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_CLOSE,pos);
      double maLow   = iMA(NULL,0,MaPeriod,0,MaMetod,MODE_LOW   ,pos);
      double maHigh  = iMA(NULL,0,MaPeriod,0,MaMetod,MODE_HIGH  ,pos);

      double haOpen  = (ExtMapBuffer3[pos+1]+ExtMapBuffer4[pos+1])/2;
      double haClose = (maOpen+maHigh+maLow+maClose)/4;
      
      ExtMapBuffer3[pos]=haOpen;
      ExtMapBuffer4[pos]=haClose;
      
      double val1 = haOpen; 
      double val2 = haClose;
      
      if (StepMode>0)
      {
         if (Step>0) if( MathAbs(ExtMapBuffer3[pos]-ExtMapBuffer3[pos+1]) < Step*Point ) ExtMapBuffer3[pos]=ExtMapBuffer3[pos+1];
         if (Step>0) if( MathAbs(ExtMapBuffer4[pos]-ExtMapBuffer4[pos+1]) < Step*Point ) ExtMapBuffer4[pos]=ExtMapBuffer4[pos+1];
               val1=ExtMapBuffer3[pos];
               val2=ExtMapBuffer4[pos];
      }
      ExtMapBuffer1[pos]=val1-val2;
      ExtMapBuffer2[pos]=val2-val1;
      trend[pos] = trend[pos+1];
         if (ExtMapBuffer1[pos]>0) trend[pos] = -1;
         if (ExtMapBuffer1[pos]<0) trend[pos] =  1;
   }
   manageAlerts();
   return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message = Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" HAMA step trend changed to "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," HAMA step"),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

